/*
 * Copyright (C) 2017 Guido Berhoerster <guido+pwm@berhoerster.name>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef	MACRO_H
#define	MACRO_H

#include "tok.h"

enum macro_err {
	MACRO_ERR_OK,
	MACRO_ERR_INVALID_NAME = -1,
	MACRO_ERR_UNDEFINED_MACRO = -2,
	MACRO_ERR_RECURSIVE = -3
};

struct macro_head;
struct macro_entry;

void		macro_init(struct macro_head **);
void		macro_destroy(struct macro_head *);
enum macro_err	macro_parse(const char *, size_t, union tok **,
    struct macro_head *, struct macro_entry **);
void		macro_add(struct macro_head *, struct macro_entry *);
int		macro_expand_macros(struct macro_head *, size_t, union tok **,
    int *, char ***);

#endif /* !MACRO_H */
